#include "Input.h"
#include <LPC214x.h>

unsigned int joyx,joyy,gx,gy,gz;

void delay(int count)
{
  int j=0,i=0;

  for(j=0;j<count;j++)
  {
    /* At 60Mhz, the below loop introduces
    delay of APPROX 1 us */
    for(i=0;i<4;i++);
  }
}

void ADC_Init(void)
{
	_BIT_CLR(AD0CR,0xFF00);
	_BIT_SET(AD0CR,(ADC_ClkDiv<<8));
	SET(AD0CR,PDN);

	_BIT_CLR(AD1CR,0xFF00);
	_BIT_SET(AD1CR,(ADC_ClkDiv<<8));
	SET(AD1CR,PDN);
	
	_BIT_CLR(PINSEL1,3<<12);//AD1.7 for joy x p0.22
	_BIT_CLR(PINSEL1,3<<18);//AD0.4 for Gest X p0.25
	_BIT_CLR(PINSEL1,3<<24);//AD0.1 for joy y p0.28
	_BIT_CLR(PINSEL1,3<<26);//AD0.2 for Gest y p0.29
	_BIT_CLR(PINSEL1,3<<28);//AD0.3 for Gest z p0.30

	SET(PINSEL1,12);//AD1.7 for joy x p0.22
	SET(PINSEL1,18);//AD0.4 for Gest X p0.25
	SET(PINSEL1,24);//AD0.1 for joy y p0.28
	SET(PINSEL1,26);//AD0.2 for Gest y p0.29
	SET(PINSEL1,28);//AD0.3 for Gest z p0.30
}

unsigned int get_JOYX_data(void)
{
	unsigned int value;
	_BIT_CLR(AD1CR,0xFF);
	SET(AD1CR,JOY_X);
	AD1CR = (AD1CR & ~(7<<24))|(1<<24);//Start conversion
	while(!CHK(AD1STAT,JOY_X));//wait for conversion to complete
	value = AD1DR7;// bit 6-15 contains data
	value = value & DATA_MASK;
	value = value>>6;
	return (value);
}

unsigned int get_JOYY_data(void)
{
	unsigned int value;
	_BIT_CLR(AD0CR,0xFF);
	SET(AD0CR,JOY_Y);
	AD0CR = (AD0CR & ~(7<<24))|(1<<24);//Start conversion
	while(!CHK(AD0STAT,JOY_Y));//wait for conversion to complete
	value = AD0DR1;// bit 6-15 contains data
	value = value & DATA_MASK;
	value = value>>6;
	return (value);
}

unsigned int get_GX_data(void)
{
	unsigned int value;
	_BIT_CLR(AD0CR,0xFF);
	SET(AD0CR,Gest_X);
	AD0CR = (AD0CR & ~(7<<24))|(1<<24);//Start conversion
	while(!CHK(AD0STAT,Gest_X));//wait for conversion to complete
	value = AD0GDR;//AD0DR4;// bit 6-15 contains data
	value = value & DATA_MASK;
	value = value>>6;
	return (value);
}

unsigned int get_GY_data(void)
{
	unsigned int value;
	_BIT_CLR(AD0CR,0xFF);
	SET(AD0CR,Gest_Y);
	AD0CR = (AD0CR & ~(7<<24))|(1<<24);//Start conversion
	while(!CHK(AD0STAT,Gest_Y));//wait for conversion to complete
	value = AD0DR2;// bit 6-15 contains data
	value = value & DATA_MASK;
	value = value>>6;
	return (value);
}

unsigned int get_GZ_data(void)
{
	unsigned int value;
	_BIT_CLR(AD0CR,0xFF);
	SET(AD0CR,Gest_Z);
	AD0CR = (AD0CR & ~(7<<24))|(1<<24);//Start conversion
	while(!CHK(AD0STAT,Gest_Z));//wait for conversion to complete
	value = AD0DR3;
	value = value & DATA_MASK;// bit 6-15 contains data
	value = value>>6;
	return (value);
}
